# Copyright (c) 2016-2017 Anki, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License in the file LICENSE.txt or at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
Autogenerated python message buffer code.
Source: clad/types/animationTrigger.clad
Full command line: ../tools/message-buffers/emitters/Python_emitter.py -C ./src/ -I ../robot/clad/src/ ../coretech/vision/clad/src/ ../coretech/common/clad/src/ ../lib/util/source/anki/clad -o ../generated/cladPython// clad/types/animationTrigger.clad
"""

from __future__ import absolute_import
from __future__ import print_function

def _modify_path():
  import inspect, os, sys
  search_paths = [
    '../..',
    '../../../../tools/message-buffers/support/python',
  ]
  currentpath = os.path.abspath(os.path.dirname(inspect.getfile(inspect.currentframe())))
  for search_path in search_paths:
    search_path = os.path.normpath(os.path.abspath(os.path.realpath(os.path.join(currentpath, search_path))))
    if search_path not in sys.path:
      sys.path.insert(0, search_path)
_modify_path()

import msgbuffers

Anki = msgbuffers.Namespace()
Anki.Cozmo = msgbuffers.Namespace()

class AnimationTrigger(object):
  "Automatically-generated int_32 enumeration."
  AcknowledgeFaceInitPause                = 0
  AcknowledgeFaceNamed                    = 1
  AcknowledgeFaceUnnamed                  = 2
  AcknowledgeObject                       = 3
  AskToBeRightedLeft                      = 4
  AskToBeRightedRight                     = 5
  AudioTestAnim                           = 6
  BlockReact                              = 7
  BouncerGetIn                            = 8
  BouncerGetOut                           = 9
  BouncerIdeaToPlay                       = 10
  BouncerIntoScore1                       = 11
  BouncerIntoScore2                       = 12
  BouncerIntoScore3                       = 13
  BouncerRequestToPlay                    = 14
  BouncerTimeout                          = 15
  BouncerWait                             = 16
  BuildPyramidFirstBlockOnSide            = 17
  BuildPyramidFirstBlockUpright           = 18
  BuildPyramidLookForFace                 = 19
  BuildPyramidReactToBase                 = 20
  BuildPyramidSecondBlockOnSide           = 21
  BuildPyramidSecondBlockUpright          = 22
  BuildPyramidSuccess                     = 23
  BuildPyramidThankUser                   = 24
  BuildPyramidThirdBlockOnSide            = 25
  BuildPyramidThirdBlockUpright           = 26
  CantHandleTallStack                     = 27
  PatternGuessNewIdea                     = 28
  PatternGuessThinking                    = 29
  CodeLab123Go                            = 30
  CodeLabAmazed                           = 31
  CodeLabBored                            = 32
  CodeLabCat                              = 33
  CodeLabCelebrate                        = 34
  CodeLabChatty                           = 35
  CodeLabConducting                       = 36
  CodeLabCurious                          = 37
  CodeLabDancingMambo                     = 38
  CodeLabDejected                         = 39
  CodeLabDizzy                            = 40
  CodeLabDizzyEnd                         = 41
  CodeLabDog                              = 42
  CodeLabEnter                            = 43
  CodeLabExcited                          = 44
  CodeLabExit                             = 45
  CodeLabFireTruck                        = 46
  CodeLabFrustrated                       = 47
  CodeLabGetInPos                         = 48
  CodeLabHappy                            = 49
  CodeLabIDK                              = 50
  CodeLabIdle                             = 51
  CodeLabLose                             = 52
  CodeLabNo                               = 53
  CodeLabPartyTime                        = 54
  CodeLabReactHappy                       = 55
  CodeLabSleep                            = 56
  CodeLabSneeze                           = 57
  CodeLabSurprise                         = 58
  CodeLabTakaTaka                         = 59
  CodeLabTapCube                          = 60
  CodeLabThinking                         = 61
  CodeLabUnhappy                          = 62
  CodeLabVictory                          = 63
  CodeLabWhee1                            = 64
  CodeLabWhee2                            = 65
  CodeLabWhee3                            = 66
  CodeLabWhee4                            = 67
  CodeLabWhew                             = 68
  CodeLabWhoa                             = 69
  CodeLabWin                              = 70
  CodeLabWondering                        = 71
  CodeLabYes                              = 72
  ConnectWakeUp                           = 73
  ConnectWakeUp_SevereEnergy              = 74
  ConnectWakeUp_SevereRepair              = 75
  ComeHere_AlreadyHere                    = 76
  ComeHere_SearchForFace                  = 77
  ComeHere_SearchForFace_FoundFace        = 78
  CozmoSaysGetIn                          = 79
  CozmoSaysGetOut                         = 80
  CozmoSaysSpeakGetInShort                = 81
  CozmoSaysSpeakGetInMedium               = 82
  CozmoSaysSpeakGetInLong                 = 83
  CozmoSaysSpeakGetOutShort               = 84
  CozmoSaysSpeakGetOutMedium              = 85
  CozmoSaysSpeakGetOutLong                = 86
  CozmoSaysSpeakLoop                      = 87
  CozmoSaysBadWord                        = 88
  CozmoSaysIdle                           = 89
  CubeMovedSense                          = 90
  CubeMovedUpset                          = 91
  CubePounceFake                          = 92
  CubePounceGetIn                         = 93
  CubePounceGetOut                        = 94
  CubePounceGetReady                      = 95
  CubePounceGetUnready                    = 96
  CubePounceIdleLiftDown                  = 97
  CubePounceIdleLiftUp                    = 98
  CubePounceLoseHand                      = 99
  CubePounceLoseRound                     = 100
  CubePounceLoseSession                   = 101
  CubePouncePounceClose                   = 102
  CubePouncePounceNormal                  = 103
  CubePounceWinHand                       = 104
  CubePounceWinRound                      = 105
  CubePounceWinSession                    = 106
  DanceMambo                              = 107
  DemoSpeedTapCozmoWin                    = 108
  DemoSpeedTapCozmoLose                   = 109
  DizzyReactionHard                       = 110
  DizzyReactionMedium                     = 111
  DizzyReactionSoft                       = 112
  DizzyShakeLoop                          = 113
  DizzyShakeStop                          = 114
  DizzyStillPickedUp                      = 115
  DriveEndAngry                           = 116
  DriveEndDefault                         = 117
  DriveEndHappy                           = 118
  DriveEndLaunch                          = 119
  DriveLoopAngry                          = 120
  DriveLoopDefault                        = 121
  DriveLoopHappy                          = 122
  DriveLoopLaunch                         = 123
  DriveStartAngry                         = 124
  DriveStartDefault                       = 125
  DriveStartHappy                         = 126
  DriveStartLaunch                        = 127
  DroneModeBackwardDrivingEnd             = 128
  DroneModeBackwardDrivingLoop            = 129
  DroneModeBackwardDrivingStart           = 130
  DroneModeCliffEvent                     = 131
  DroneModeForwardDrivingEnd              = 132
  DroneModeForwardDrivingLoop             = 133
  DroneModeForwardDrivingStart            = 134
  DroneModeGetIn                          = 135
  DroneModeGetOut                         = 136
  DroneModeIdle                           = 137
  DroneModeKeepAlive                      = 138
  DroneModeTurboDrivingStart              = 139
  EarnedSparks                            = 140
  FacePlantRoll                           = 141
  FacePlantRollArmUp                      = 142
  FailedToRightFromFace                   = 143
  FeedingAteFullEnough_Normal             = 144
  FeedingAteFullEnough_Severe             = 145
  FeedingAteNotFullEnough_Normal          = 146
  FeedingAteNotFullEnough_Severe          = 147
  FeedingDrivingGetIn_Severe              = 148
  FeedingDrivingGetOut_Severe             = 149
  FeedingDrivingLoop_Severe               = 150
  FeedingPlaceLiftOnCube_Normal           = 151
  FeedingPlaceLiftOnCube_Severe           = 152
  FeedingIdleSearch_Normal                = 153
  FeedingIdleSearch_Severe                = 154
  FeedingIdleSearchForFaces_Normal        = 155
  FeedingIdleSearchForFaces_Severe        = 156
  FeedingIdleWaitForFullCube_Normal       = 157
  FeedingIdleWaitForFullCube_Severe       = 158
  FeedingIdleWaitForShakeNoHead_Severe    = 159
  FeedingIdleWaitForShake_Normal          = 160
  FeedingIdleWaitForShake_Severe          = 161
  FeedingInterrupted                      = 162
  FeedingInterrupted_Severe               = 163
  FeedingSearchRequest                    = 164
  FeedingSearchRequest_Severe             = 165
  FeedingSearchFailure                    = 166
  FeedingSearchFailure_Severe             = 167
  FeedingReactToFullCube_Normal           = 168
  FeedingReactToFullCube_Severe           = 169
  FeedingReactToSeeCube_Normal            = 170
  FeedingReactToSeeCube_Severe            = 171
  FeedingReactToShake_Normal              = 172
  FeedingReactToShake_Severe              = 173
  FistBumpIdle                            = 174
  FistBumpRequestOnce                     = 175
  FistBumpRequestRetry                    = 176
  FistBumpSuccess                         = 177
  FistBumpLeftHanging                     = 178
  FlipDownFromBack                        = 179
  FrustratedByFailure                     = 180
  FrustratedByFailureMajor                = 181
  GameSetupGetIn                          = 182
  GameSetupGetOut                         = 183
  GameSetupIdle                           = 184
  GameSetupReaction                       = 185
  GoToSleepGetIn                          = 186
  GoToSleepGetOut                         = 187
  GoToSleepOff                            = 188
  GoToSleepSleeping                       = 189
  GuardDogBusted                          = 190
  GuardDogCubeDisconnect                  = 191
  GuardDogFakeout                         = 192
  GuardDogInterruption                    = 193
  GuardDogPlayerSuccess                   = 194
  GuardDogPulse                           = 195
  GuardDogSettle                          = 196
  GuardDogSleepLoop                       = 197
  GuardDogTimeout                         = 198
  GuardDogTimeoutCubesTouched             = 199
  GuardDogTimeoutCubesUntouched           = 200
  Hiccup                                  = 201
  HiccupGetIn                             = 202
  HiccupPlayerCure                        = 203
  HiccupRobotOnBack                       = 204
  HiccupRobotOnFace                       = 205
  HiccupRobotPickedUp                     = 206
  HiccupSelfCure                          = 207
  HikingDrivingEnd                        = 208
  HikingDrivingLoop                       = 209
  HikingDrivingStart                      = 210
  HikingInterestingEdgeThought            = 211
  HikingIntro                             = 212
  HikingLookAround                        = 213
  HikingObserve                           = 214
  HikingReactToEdge                       = 215
  HikingReactToNewArea                    = 216
  HikingReactToPossibleMarker             = 217
  HikingSquintEnd                         = 218
  HikingSquintLoop                        = 219
  HikingSquintStart                       = 220
  HikingWakeUpOffCharger                  = 221
  IdleOnCharger                           = 222
  InteractWithFaceTrackingIdle            = 223
  InteractWithFacesInitialNamed           = 224
  InteractWithFacesInitialUnnamed         = 225
  KnockOverEyes                           = 226
  KnockOverFailure                        = 227
  KnockOverGrabAttempt                    = 228
  KnockOverPreActionNamedFace             = 229
  KnockOverPreActionUnnamedFace           = 230
  KnockOverSuccess                        = 231
  LaserAcknowledge                        = 232
  LaserDriveEnd                           = 233
  LaserDriveLoop                          = 234
  LaserDriveStart                         = 235
  LaserFace                               = 236
  LaserGetOut                             = 237
  LaserPounce                             = 238
  LookInPlaceForFacesBodyPause            = 239
  LookInPlaceForFacesHeadMovePause        = 240
  MajorFail                               = 241
  MajorWin                                = 242
  MeetCozmoGetIn                          = 243
  MeetCozmoLookFaceGetIn                  = 244
  MeetCozmoLookFaceGetOut                 = 245
  MeetCozmoScanningIdle                   = 246
  MeetCozmoFirstEnrollmentSayName         = 247
  MeetCozmoFirstEnrollmentRepeatName      = 248
  MeetCozmoFirstEnrollmentCelebration     = 249
  MeetCozmoReEnrollmentSayName            = 250
  MeetCozmoRenameFaceSayName              = 251
  MeetCozmoLookFaceInterrupt              = 252
  MemoryMatchPlayerWinHand                = 253
  MemoryMatchPlayerWinHandLong            = 254
  MemoryMatchPlayerWinHandSolo            = 255
  MemoryMatchPlayerLoseHand               = 256
  MemoryMatchPlayerLoseHandSolo           = 257
  MemoryMatchCozmoWinHand                 = 258
  MemoryMatchCozmoLoseHand                = 259
  MemoryMatchCozmoWinGame                 = 260
  MemoryMatchPlayerWinGame                = 261
  MemoryMatchSoloGameOver                 = 262
  MemoryMatchReactToPattern               = 263
  MemoryMatchReactToPatternSolo           = 264
  MemoryMatchPointCenter                  = 265
  MemoryMatchPointLeftBig                 = 266
  MemoryMatchPointLeftSmall               = 267
  MemoryMatchPointRightBig                = 268
  MemoryMatchPointRightSmall              = 269
  MemoryMatchPointCenterFast              = 270
  MemoryMatchPointLeftBigFast             = 271
  MemoryMatchPointLeftSmallFast           = 272
  MemoryMatchPointRightBigFast            = 273
  MemoryMatchPointRightSmallFast          = 274
  MemoryMatchCozmoGetOut                  = 275
  MemoryMatchCozmoFollowTapsSoundOnly     = 276
  NamedFaceInitialGreeting                = 277
  NeedsMildLowEnergyRequest               = 278
  NeedsMildLowPlayRequest                 = 279
  NeedsMildLowRepairRequest               = 280
  NeedsSevereLowEnergyCliffReact          = 281
  NeedsSevereLowEnergyDrivingEnd          = 282
  NeedsSevereLowEnergyDrivingLoop         = 283
  NeedsSevereLowEnergyDrivingStart        = 284
  NeedsSevereLowEnergyForceGetOut         = 285
  NeedsSevereLowEnergyGetIn               = 286
  NeedsSevereLowEnergyIdle                = 287
  NeedsSevereLowEnergyRequest             = 288
  NeedsSevereLowEnergySlopeReact          = 289
  NeedsSevereLowPlayForceGetOut           = 290
  NeedsSevereLowPlayGetIn                 = 291
  NeedsSevereLowPlayRequest               = 292
  NeedsSevereLowRepairCliffReact          = 293
  NeedsSevereLowRepairDrivingEnd          = 294
  NeedsSevereLowRepairDrivingLoop         = 295
  NeedsSevereLowRepairDrivingStart        = 296
  NeedsSevereLowRepairForceGetOut         = 297
  NeedsSevereLowRepairGetIn               = 298
  NeedsSevereLowRepairIdle                = 299
  NeedsSevereLowRepairRequest             = 300
  NeedsSevereLowRepairSlopeReact          = 301
  NeutralFace                             = 302
  NothingToDoBoredEvent                   = 303
  NothingToDoBoredIdle                    = 304
  NothingToDoBoredIntro                   = 305
  NothingToDoBoredOutro                   = 306
  OnLearnedPlayerName                     = 307
  OnSawNewNamedFace                       = 308
  OnSawNewUnnamedFace                     = 309
  OnSawOldNamedFace                       = 310
  OnSawOldUnnamedFace                     = 311
  OnSpeedtapCozmoConfirm                  = 312
  OnSpeedtapFakeout                       = 313
  OnSpeedtapGameCozmoWinHighIntensity     = 314
  OnSpeedtapGameCozmoWinLowIntensity      = 315
  OnSpeedtapGamePlayerWinHighIntensity    = 316
  OnSpeedtapGamePlayerWinLowIntensity     = 317
  OnSpeedtapGetOut                        = 318
  OnSpeedtapHandCozmoWin                  = 319
  OnSpeedtapHandPlayerWin                 = 320
  OnSpeedtapIdle                          = 321
  OnSpeedtapRoundCozmoWinHighIntensity    = 322
  OnSpeedtapRoundCozmoWinLowIntensity     = 323
  OnSpeedtapRoundPlayerWinHighIntensity   = 324
  OnSpeedtapRoundPlayerWinLowIntensity    = 325
  OnSpeedtapTap                           = 326
  OnWaitForCubesMinigameSetup             = 327
  OnWiggle                                = 328
  OnboardingBirth                         = 329
  OnboardingCubeDockFail                  = 330
  OnboardingDiscoverCube                  = 331
  OnboardingDriveEnd                      = 332
  OnboardingDriveLoop                     = 333
  OnboardingDriveStart                    = 334
  OnboardingEyesOn                        = 335
  OnboardingHelloPlayer                   = 336
  OnboardingHelloWorld                    = 337
  OnboardingIdle                          = 338
  OnboardingIdleEnergy                    = 339
  OnboardingIdlePlay                      = 340
  OnboardingIdleRepair                    = 341
  OnboardingInteractWithCube              = 342
  OnboardingPreBirth                      = 343
  OnboardingReactToCube                   = 344
  OnboardingReactToCubePutDown            = 345
  OnboardingReactToFace                   = 346
  OnboardingSoundOnlyLiftEffortPickup     = 347
  OnboardingSoundOnlyLiftEffortPlaceLow   = 348
  OnboardingGetOut                        = 349
  OnboardingWakeUpDriveOffCharger         = 350
  PeekABooGetIn                           = 351
  PeekABooGetOutHappy                     = 352
  PeekABooGetOutSad                       = 353
  PeekABooHighIntensity                   = 354
  PeekABooIdle                            = 355
  PeekABooLowIntensity                    = 356
  PeekABooMedIntensity                    = 357
  PeekABooNoUserInteraction               = 358
  PeekABooShort                           = 359
  PeekABooSurprised                       = 360
  PetDetectionCat                         = 361
  PetDetectionDog                         = 362
  PetDetectionShort                       = 363
  PetDetectionShort_Cat                   = 364
  PetDetectionShort_Dog                   = 365
  PetDetectionSneeze                      = 366
  PickupHelperPreActionNamedFace          = 367
  PickupHelperPreActionUnnamedFace        = 368
  PlacedOnCharger                         = 369
  PopAWheelieInitial                      = 370
  PopAWheeliePreActionNamedFace           = 371
  PopAWheeliePreActionUnnamedFace         = 372
  PopAWheelieRealign                      = 373
  PopAWheelieRetry                        = 374
  PounceDriveEnd                          = 375
  PounceDriveLoop                         = 376
  PounceDriveStart                        = 377
  PounceFace                              = 378
  PounceFail                              = 379
  PounceGetOut                            = 380
  PounceInitial                           = 381
  PouncePounce                            = 382
  PounceSuccess                           = 383
  ProceduralLive                          = 384
  PutDownBlockKeepAlive                   = 385
  PutDownBlockPutDown                     = 386
  ReactToBlockPickupSuccess               = 387
  ReactToBlockRetryPickup                 = 388
  ReactToCliff                            = 389
  ReactToCliffDetectorStop                = 390
  ReactToFalling                          = 391
  ReactToImpact                           = 392
  ReactToObstacle                         = 393
  ReactToMotorCalibration                 = 394
  ReactToNewBlockAsk                      = 395
  ReactToNewBlockBig                      = 396
  ReactToNewBlockSmall                    = 397
  ReactToOnLeftSide                       = 398
  ReactToOnRightSide                      = 399
  ReactToPerchedOnBlock                   = 400
  ReactToPickup                           = 401
  ReactToPokeReaction                     = 402
  ReactToPokeStartled                     = 403
  ReactToUnexpectedMovement               = 404
  ReactToUnexpectedMovement_Severe_Energy = 405
  ReactToUnexpectedMovement_Severe_Repair = 406
  RepairFailMild                          = 407
  RepairFailSevere                        = 408
  RepairFixMildGetIn                      = 409
  RepairFixMildGetOut                     = 410
  RepairFixMildGetReady                   = 411
  RepairFixMildHeadDown                   = 412
  RepairFixMildHeadUp                     = 413
  RepairFixMildIdle                       = 414
  RepairFixMildLiftDown                   = 415
  RepairFixMildLiftUp                     = 416
  RepairFixMildLowerLift                  = 417
  RepairFixMildRaiseLift                  = 418
  RepairFixMildRoundReact                 = 419
  RepairFixMildWheelsBack                 = 420
  RepairFixMildWheelsForward              = 421
  RepairFixSevereGetIn                    = 422
  RepairFixSevereGetOut                   = 423
  RepairFixSevereGetReady                 = 424
  RepairFixSevereHeadDown                 = 425
  RepairFixSevereHeadUp                   = 426
  RepairFixSevereIdle                     = 427
  RepairFixSevereLiftDown                 = 428
  RepairFixSevereLiftUp                   = 429
  RepairFixSevereLowerLift                = 430
  RepairFixSevereRaiseLift                = 431
  RepairFixSevereRoundReact               = 432
  RepairFixSevereWheelsBack               = 433
  RepairFixSevereWheelsForward            = 434
  RepairIdleFullyRepaired                 = 435
  RepairPartRepaired_Head_Mild            = 436
  RepairPartRepaired_Lift_Mild            = 437
  RepairPartRepaired_Tread_Mild           = 438
  RequestGameInterrupt                    = 439
  RequestGameKeepAwayAccept0              = 440
  RequestGameKeepAwayAccept1              = 441
  RequestGameKeepAwayDeny0                = 442
  RequestGameKeepAwayDeny1                = 443
  RequestGameKeepAwayIdle0                = 444
  RequestGameKeepAwayIdle1                = 445
  RequestGameKeepAwayInitial0             = 446
  RequestGameKeepAwayInitial1             = 447
  RequestGameKeepAwayPreDrive0            = 448
  RequestGameKeepAwayPreDrive1            = 449
  RequestGameKeepAwayRequest0             = 450
  RequestGameKeepAwayRequest1             = 451
  RequestGameMemoryMatchAccept0           = 452
  RequestGameMemoryMatchAccept1           = 453
  RequestGameMemoryMatchDeny0             = 454
  RequestGameMemoryMatchDeny1             = 455
  RequestGameMemoryMatchIdle0             = 456
  RequestGameMemoryMatchIdle1             = 457
  RequestGameMemoryMatchInitial0          = 458
  RequestGameMemoryMatchInitial1          = 459
  RequestGameMemoryMatchPreDrive0         = 460
  RequestGameMemoryMatchPreDrive1         = 461
  RequestGameMemoryMatchRequest0          = 462
  RequestGameMemoryMatchRequest1          = 463
  RequestGamePickupFail                   = 464
  RequestGameSpeedTapAccept0              = 465
  RequestGameSpeedTapAccept1              = 466
  RequestGameSpeedTapDeny0                = 467
  RequestGameSpeedTapDeny1                = 468
  RequestGameSpeedTapIdle0                = 469
  RequestGameSpeedTapIdle1                = 470
  RequestGameSpeedTapInitial0             = 471
  RequestGameSpeedTapInitial1             = 472
  RequestGameSpeedTapPreDrive0            = 473
  RequestGameSpeedTapPreDrive1            = 474
  RequestGameSpeedTapRequest0             = 475
  RequestGameSpeedTapRequest1             = 476
  RollBlockInitial                        = 477
  RollBlockPreActionNamedFace             = 478
  RollBlockPreActionUnnamedFace           = 479
  RollBlockPutDown                        = 480
  RollBlockRealign                        = 481
  RollBlockRetry                          = 482
  RollBlockSuccess                        = 483
  SdkTextToSpeech                         = 484
  Shiver                                  = 485
  Shocked                                 = 486
  Singing_80bpm                           = 487
  Singing_100bpm                          = 488
  Singing_120bpm                          = 489
  Singing_GetIn                           = 490
  Singing_GetOut                          = 491
  Sleeping                                = 492
  SoftSparkUpgradeLift                    = 493
  SoftSparkUpgradeTracks                  = 494
  SoundOnlyLiftEffortPickup               = 495
  SoundOnlyLiftEffortPlaceHigh            = 496
  SoundOnlyLiftEffortPlaceLow             = 497
  SoundOnlyLiftEffortPlaceRoll            = 498
  SoundOnlyRamIntoBlock                   = 499
  SoundOnlyTurnSmall                      = 500
  SparkDrivingLoop                        = 501
  SparkDrivingStart                       = 502
  SparkDrivingStop                        = 503
  SparkFailure                            = 504
  SparkGetIn                              = 505
  SparkGetOut                             = 506
  SparkIdle                               = 507
  SparkPickupFinalCubeReaction            = 508
  SparkPickupInitialCubeReaction          = 509
  SparkSuccess                            = 510
  SpeedTapDrivingEnd                      = 511
  SpeedTapDrivingLoop                     = 512
  SpeedTapDrivingStart                    = 513
  StackBlocksSuccess                      = 514
  StartSleeping                           = 515
  SuccessfulWheelie                       = 516
  Surprise                                = 517
  TurtleRoll                              = 518
  UnitTestAnim                            = 519
  VC_Alrighty                             = 520
  VC_HowAreYouDoing_AllGood               = 521
  VC_Listening                            = 522
  VC_LookDownForLaser                     = 523
  VC_LookDownNoLaser                      = 524
  VC_NoFollowupCommand_NoFace             = 525
  VC_NoFollowupCommand_WithFace           = 526
  VC_Refuse_energy                        = 527
  VC_Refuse_repair                        = 528
  VC_Refuse_sparks                        = 529
  VC_StartledWakeup                       = 530
  WaitOnSideLoop                          = 531
  WorkoutPostLift_highEnergy              = 532
  WorkoutPostLift_lowEnergy               = 533
  WorkoutPostLift_mediumEnergy            = 534
  WorkoutPreLift_highEnergy               = 535
  WorkoutPreLift_lowEnergy                = 536
  WorkoutPreLift_mediumEnergy             = 537
  WorkoutPutDown_highEnergy               = 538
  WorkoutPutDown_lowEnergy                = 539
  WorkoutPutDown_lowEnergy_simple         = 540
  WorkoutPutDown_mediumEnergy             = 541
  WorkoutStrongLift_highEnergy            = 542
  WorkoutStrongLift_lowEnergy             = 543
  WorkoutStrongLift_mediumEnergy          = 544
  WorkoutTransition_highEnergy            = 545
  WorkoutTransition_lowEnergy             = 546
  WorkoutTransition_mediumEnergy          = 547
  WorkoutWeakLift_highEnergy              = 548
  WorkoutWeakLift_lowEnergy               = 549
  WorkoutWeakLift_mediumEnergy            = 550
  Count                                   = 551

Anki.Cozmo.AnimationTrigger = AnimationTrigger
del AnimationTrigger


class CubeAnimationTrigger(object):
  "Automatically-generated int_32 enumeration."
  Carrying                    = 0
  Connected                   = 1
  CubePouncePlayerLose        = 2
  CubePouncePlayerWin         = 3
  Dance_01                    = 4
  Dance_02                    = 5
  Dance_03                    = 6
  Dance_04                    = 7
  Dance_05                    = 8
  Dance_06                    = 9
  DanceFadeOff                = 10
  DrivingTo                   = 11
  FeedingBlank                = 12
  FeedingCyanCycle            = 13
  FeedingCyanSolid            = 14
  Flash                       = 15
  GatherCubesAllCubesInBeacon = 16
  GatherCubesCubeInBeacon     = 17
  GuardDogBeingMoved          = 18
  GuardDogBusted              = 19
  GuardDogOff                 = 20
  GuardDogSetup               = 21
  GuardDogSleeping            = 22
  GuardDogSuccessfullyFlipped = 23
  Interacting                 = 24
  InteractingBehaviorLock     = 25
  Onboarding                  = 26
  PyramidBaseBottom           = 27
  PyramidFlourish             = 28
  PyramidOnSideLocated        = 29
  PyramidOnSideNotLocated     = 30
  PyramidPickup               = 31
  PyramidSingle               = 32
  Sleep                       = 33
  SleepNoFade                 = 34
  SpeedTapWin                 = 35
  SpeedTapLose                = 36
  Visible                     = 37
  WakeUp                      = 38
  Workout                     = 39
  Count                       = 40

Anki.Cozmo.CubeAnimationTrigger = CubeAnimationTrigger
del CubeAnimationTrigger


